package biu.books.catalog;

import java.util.List;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.select.SelectorComposer;
import org.zkoss.zk.ui.select.annotation.Listen;
import org.zkoss.zk.ui.select.annotation.Wire;
import org.zkoss.zul.Image;
import org.zkoss.zul.Label;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.Listbox;
import org.zkoss.zul.Textbox;

public class SearchController extends SelectorComposer<Component> {
	
	private static final long serialVersionUID = 1L;
	
	@Wire
	private Textbox keywordBox;
	@Wire
	private Listbox bookListbox;
	@Wire
	private Label titleLabel;
	@Wire
	private Label publisherLabel;
	@Wire
	private Label priceLabel;
	@Wire
	private Label descriptionLabel;
	@Wire
	private Image previewImage;
	
	
	private BookService bookService = new BookServiceImpl();

	@Listen("onClick = #searchButton")
	public void search(){
		String keyword = keywordBox.getValue();
		List<Book> result = bookService.search(keyword);
		bookListbox.setModel(new ListModelList<Book>(result));
	}
	
	
	@Listen("onSelect = #bookListbox")
	public void showDetail() {
		Book selected = bookListbox.getSelectedItem().getValue();
		previewImage.setSrc(selected.getPreview());
		titleLabel.setValue(selected.getTitle());
		publisherLabel.setValue(selected.getPublisher());
		priceLabel.setValue(selected.getPrice().toString());
		descriptionLabel.setValue(selected.getDescription());
	}
}
